;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;  mapsysa.asm
;       
;  Purpose:       
;       Assembly language routines for VxD-->SYS mapper example
;  
;
;  Author:  Dr. Iver
;
;  Copyright(c) 1997 Microsoft Corporation
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.386p

        .xlist
        INCLUDE VMM.INC
        .list

        Create_MAPSYS_Service_Table = 1
        include mapsysa.inc
        
Declare_Virtual_Device MAPSYS, 1, 0, \
                MAPSYS_Control, MAPSYS_DEVICE_ID, Undefined_Init_Order



VxD_Locked_Data_Seg

current_msg                     db      0

VxD_Locked_Data_Ends

VxD_Locked_Code_Seg


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;  MAPSYS_Control
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
BeginProc MAPSYS_Control, PUBLIC

        mov current_msg, al

        clc
        ret

EndProc MAPSYS_Control

;
; Expose the VxD interface to mousebtn.vxd via the VMM_Add_DDB routine
;

BeginProc MAPSYS_Init_VxD, SCALL, PUBLIC

        EnterProc
        SaveReg <ebx, esi, edi>
        
        mov     edi, offset32 MAPSYS_DDB
        VMMCall VMM_Add_DDB
        cmc
        sbb     eax, eax
        
        RestoreReg <edi, esi, ebx>
        LeaveProc
    Return

EndProc MAPSYS_Init_VxD


BeginProc MAPSYS_GetVersion, Service
        mov eax, 1H
        clc
        ret
EndProc MAPSYS_GetVersion        

BeginProc MAPSYS_OpenMouse, Service
        scall _OpenMouseFromVxD
        clc
        ret
EndProc MAPSYS_OpenMouse         


BeginProc MAPSYS_ReadButtons, Service
        scall _ReadButtonsFromVxD <EAX, ECX>
        clc
        ret
EndProc MAPSYS_ReadButtons       


BeginProc MAPSYS_CloseMouse, Service 
        scall _CloseMouseFromVxD <EAX>
        clc
        ret
EndProc MAPSYS_CloseMouse        

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


VxD_Locked_Code_Ends
        end
